package dev.shadowsoffire.apotheosis.adventure.boss;

import net.minecraft.world.entity.Entity;
import java.util.function.Predicate;
import javax.annotation.Nullable;
import net.minecraft.world.entity.EntityType;
import java.util.Set;
import com.mojang.serialization.Codec;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.placebo.codec.CodecProvider;
import net.minecraft.resources.ResourceLocation;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import dev.shadowsoffire.placebo.reload.WeightedDynamicRegistry;

public class MinibossRegistry extends WeightedDynamicRegistry<ApothMiniboss>
{
    public static final MinibossRegistry INSTANCE;
    
    public MinibossRegistry() {
        super(AdventureModule.LOGGER, "minibosses", false, false);
    }
    
    protected void validateItem(final ResourceLocation key, final ApothMiniboss item) {
        super.validateItem(key, (CodecProvider)item);
        item.validate(key);
    }
    
    protected void registerBuiltinCodecs() {
        this.registerDefaultCodec(Apotheosis.loc("miniboss"), (Codec)ApothMiniboss.CODEC);
    }
    
    static {
        INSTANCE = new MinibossRegistry();
    }
    
    public interface IEntityMatch
    {
        @Nullable
        Set<EntityType<?>> getEntities();
        
        default <T extends IEntityMatch> Predicate<T> matches(final EntityType<?> type) {
            return obj -> {
                final Set<EntityType<?>> types = obj.getEntities();
                return types == null || types.isEmpty() || types.contains(type);
            };
        }
        
        default <T extends IEntityMatch> Predicate<T> matches(final Entity entity) {
            return matches((EntityType<?>)entity.m_6095_());
        }
    }
}
